<template>
    <div class="list-view">
        <page-title>
            <el-button @click="addRow" type="primary" icon="el-icon-plus" :loading="downloading" class="filter-item">
                新增
            </el-button>
            <el-button @click="download" icon="el-icon-upload2" :loading="downloading" class="filter-item">
                导出
            </el-button>
        </page-title>
        <div class="filters-container">
            <el-input
                placeholder="搜索..."
                v-model="search"
                clearable
                class="filter-item search"
                @keyup.enter.native="getData"
            >
                <el-button @click="getData" slot="append" icon="el-icon-search"> </el-button>
            </el-input>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="applyStatus" label="案件状态" :formatter="applyStatusFormatter"> </el-table-column>
            <el-table-column prop="uwNo" label="寰球案号"> </el-table-column>
            <el-table-column prop="name" label="专利名称"> </el-table-column>
            <el-table-column prop="logoWorkflow" label="当前流程" :formatter="logoWorkflowFormatter"> </el-table-column>
            <el-table-column prop="userId" label="创建申请人"> </el-table-column>
            <el-table-column prop="createdAt" label="商标申请日"> </el-table-column>
            <el-table-column prop="clientPartner" label="客户"> </el-table-column>
            <el-table-column prop="supplierPartner" label="供应商"> </el-table-column>
            <el-table-column prop="applyNo" label="商标申请号"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="80">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看详情</el-button>
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import logoPatent from '@/mixins/logoPatent';

export default {
    name: 'LogoPatentList',
    mixins: [pageableTable, logoPatent],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/logoPatent/all',
            downloading: false
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            return { search: this.search };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/logoPatentAdd',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/logoPatentEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/logoPatent/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/logoPatent/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped></style>
